# Instance Divider

## Environment

Please use Anaconda3-4.2 or previous versions.
We confirmed that this softwore operated on the following environments.

* MacOS X 10.11.6, Anaconda3-4.2.0
* Ubuntu 16.04.2 LTS, Anaconda3-4.2.0
* Windows 7, Anaconda3-4.2.0

Since Anaconda does not include OpenCV, please install OpenCV with the following command.

<pre>
$ conda install -c menpo opencv3
</pre>

## Image Format for input

Only PNG is supported.

### Naming rules

* The name of input images must include "_rgb".
* The label image corresponding to the input image is the one in which "_ rgb" is replaced with "_label".
* The frame number shall be the number following "_ frame".
  For example, the frame number of "ara2012_plant01_frame05_rgb.png" is 05.
* The frame number may be discontinuous.

## How to use the software

### Open

Select an input image with File -> Open .... 
From the naming rules, only those containing "_ rgb" can be selected.
When opening an input image, its corresponding label image automatically is loaded if it exists.
If the label image of the previous frame also exists, it is also loaded.
The shortcut for Open is Ctrl-O.

### Plant Segmentation

By moving the sliders of R, G, B in the lower left of the main window, rough plant segmentation can be performed.

### Mask Modifitation

Plant segmentation is controlled with a simple threshold value, so you may recognize parts other than leaves as leaves.
Therefore, it is necessary to modify the mask.

The mask can be modified by the same operation as the dividing line (described later).
If you change the color of the pen to black or white, you can directly modify the mask.
When erasing noise generated in the surroundings, noise can be removed efficiently by increasing the brush size.

### Division line

When drawing a division line, please select a color with a combo box beforehand.
Note that the start and end points must be black pixels of the mask.

### Integration

In the configuration of this software, a division line layer exists on the mask. (See view configuration)
Integration must be done before separating the leaves separately.

### Leaf Segmentation

As for leaf segmentation, please select colors in advance.
Then, when you click on the white part, the closed curve is filled with a single color.

### Zoom, Pan

To zoom, please hold down the Control key and rotate the mouse wheel.
To pan, similarly, please drag the mouse while holding down the Control key.

### Undo, Redo

Undo can be done for separating separating lines and leaves.
To do undo, Edit -> Undo or Ctrl - Z.
Redo is Edit -> Redo or Ctrl - Shift - Z.

### Show previous frame

If there is a mask image of the previous frame at the time of opening, it is loaded.
Then, to show this image, please put a check in the check box of "Show previous frame".
The display of the previous frame and the original image is exclusive.

## View configuration

In order from the top (front)

* Pen Layer: Division Line
* Mask layer: Mask image
* Previous frame layer
* Original image : Original image

The reasons for separating pen layer and mask layer are as follows.

* Implementation of undo operation on dividing line becomes easy
* Reasonable for memory and CPU resources

It seems that it is divided on the display, but since each of them exists independently, it is actually in a state where it is not divided.
Therefore, it is possible to divide the mask layer by unify the pen layer into the mask layer.

## leaf.csv

Leaf color is defined by leaf.csv.
The instance splitting tool reads this file at startup and sets it in a combo box.

The character code of leaf.csv is utf-8. The format is as follows.

<pre>
  Name, red value, green value, blue value
</pre>

For example,

<pre>
leaf1,   0,   0, 255
leaf2,   0, 255,   0
leaf3,   0, 255, 255
leaf4, 255,   0,   0
leaf5, 255,   0, 255
leaf6, 255, 255,   0
Mask,   0,   0,   0
Plant,    255, 255, 255
</pre>

## screen structure

1. Enable / Disable Plant Segmentation Sliders If you uncheck the items (2) to (8) are invalid
2. Red threshold slider for plant segmentation
3. Red Threshold Spin Box for Plant Segmentation
4. Green threshold slider for plant segmentation
5. Green Threshold Spin Box for Plant Segmentation
6. Blue threshold slider for plant segmentation
7. Blue Threshold Spin Box for Plant Segmentation
8. Move the RGB slider synchronously
9. Selection color of dividing line
10. Dividing line thickness slider
11. Dividing line thickness spin box
12. Opacity of the mask. 
13. Display of the mask of the previous frame.
    The mask of the previous frame and the original picture are displayed exclusively.If there is no mask of the previous frame, it is grayed out
14. Save the mask
15. Unify dividing lines into mask

![screen structure](doc/ss.png)
