import sys
from PyQt5.QtWidgets import QUndoCommand, QUndoStack


class UndoPen(QUndoCommand):
    def __init__(self, penItem, penLines, parent=None):
        super().__init__(parent)
        self.penItem = penItem
        self.penLines = penLines
        self.redoLine = None

    def undo(self):
        self.redoLine = self.penLines.pop()
        self.penItem.update()

    def redo(self):
        if self.redoLine is not None:
            self.penLines.append(self.redoLine)
            self.penItem.update()


class UndoMask(QUndoCommand):
    def __init__(self, item, oldPixmap, newPixmap, parent=None):
        super().__init__(parent)
        self.item = item
        self.oldPixmap = oldPixmap
        self.newPixmap = newPixmap

    def undo(self):
        self.item.setPixmap(self.oldPixmap)

    def redo(self):
        self.item.setPixmap(self.newPixmap)
